#
# This module add the VTK include paths to a project
# It should be included after the FindVTK module
#
IF (USE_INSTALLED_VTK)
  IF (VTK_INSTALL_PATH)
    LOAD_CACHE(${VTK_INSTALL_PATH}/include/vtk 
      EXCLUDE
        BUILD_DOCUMENTATION
        BUILD_SHARED_LIBS
        BUILD_TESTING
        BUILD_EXAMPLES
        DOCUMENTATION_HTML_HELP
        DOCUMENTATION_HTML_TARZ
        LIBRARY_OUTPUT_PATH
        EXECUTABLE_OUTPUT_PATH
        MAKECOMMAND
        SITE
        BUILDNAME
        VTK_WRAP_HINTS
        VTK_PARSE_JAVA_EXE
        VTK_WRAP_JAVA_EXE
        VTK_WRAP_PYTHON_EXE
        VTK_WRAP_TCL_EXE
        TCL_INCLUDE_PATH
        TCL_LIBRARY
        TCL_TCLSH
        TK_INCLUDE_PATH
        TK_INTERNAL_PATH
        TK_LIBRARY
        TK_WISH
        TK_XLIB_PATH
        PYTHON_DEBUG_LIBRARY
        PYTHON_INCLUDE_PATH
        PYTHON_LIBRARY
        JAVA_AWT_LIBRARY
        JAVA_INCLUDE_PATH
        JAVA_INCLUDE_PATH2
        JAVA_AWT_INCLUDE_PATH
        VTK_JAVA_HOME  
        VTK_INSTALL_PATH
        USE_BUILT_VTK
        VTK_BINARY_PATH
        USE_INSTALLED_VTK
        USE_VTK_FILE 
      INCLUDE_INTERNALS
        VTK_BINARY_DIR
        VTK_BUILD_SHARED_LIBS
        VTK_LIBRARY_PATH
      )
    INCLUDE_DIRECTORIES ( ${VTK_INSTALL_PATH}/include/vtk )
    LINK_DIRECTORIES(${VTK_INSTALL_PATH}/lib/vtk)
    IF (VTK_WRAP_TCL) 
      FIND_PROGRAM(VTK_WRAP_TCL_EXE
        vtkWrapTcl
        ${VTK_INSTALL_PATH}/bin)
      MARK_AS_ADVANCED(VTK_WRAP_TCL_EXE)
    ENDIF (VTK_WRAP_TCL) 
    IF (VTK_WRAP_PYTHON) 
      FIND_PROGRAM(VTK_WRAP_PYTHON_EXE
        vtkWrapPython
        ${VTK_INSTALL_PATH}/bin)
      MARK_AS_ADVANCED(VTK_WRAP_PYTHON_EXE)
    ENDIF (VTK_WRAP_PYTHON) 
    IF (VTK_WRAP_JAVA) 
      FIND_PROGRAM(VTK_WRAP_JAVA_EXE
        vtkWrapJava
        ${VTK_INSTALL_PATH}/bin)
      MARK_AS_ADVANCED(VTK_WRAP_JAVA_EXE)
      FIND_PROGRAM(VTK_PARSE_JAVA_EXE
        vtkParseJava
        ${VTK_INSTALL_PATH}/bin)
      MARK_AS_ADVANCED(VTK_PARSE_JAVA_EXE)
    ENDIF (VTK_WRAP_JAVA)
  ENDIF (VTK_INSTALL_PATH)
ELSE (USE_INSTALLED_VTK)
  IF (VTK_BINARY_PATH)
    LOAD_CACHE(${VTK_BINARY_PATH} 
      EXCLUDE
        BUILD_DOCUMENTATION
        BUILD_SHARED_LIBS
        BUILD_TESTING
        BUILD_EXAMPLES
        DOCUMENTATION_HTML_HELP
        DOCUMENTATION_HTML_TARZ
        LIBRARY_OUTPUT_PATH
        EXECUTABLE_OUTPUT_PATH
        MAKECOMMAND 
        SITE
        BUILDNAME
        VTK_WRAP_HINTS
        VTK_INSTALL_PATH
        USE_BUILT_VTK
        VTK_BINARY_PATH
        USE_INSTALLED_VTK
        USE_VTK_FILE 
      INCLUDE_INTERNALS
        VTK_BINARY_DIR
        VTK_BUILD_SHARED_LIBS
        VTK_LIBRARY_PATH
      )
    INCLUDE (${VTK_SOURCE_DIR}/vtkCMakeOptions.cmake)
    LINK_DIRECTORIES(${VTK_LIBRARY_PATH})
  ENDIF (VTK_BINARY_PATH)
ENDIF (USE_INSTALLED_VTK)

IF (VTK_USE_RENDERING)
  # add in opengl
  IF (WIN32)
    LINK_LIBRARIES ( ${OPENGL_LIBRARY} )
  ELSE (WIN32)
    IF (OPENGL_LIBRARY)
      LINK_LIBRARIES (${OPENGL_LIBRARY})
    ENDIF (OPENGL_LIBRARY)
  ENDIF (WIN32)
  IF (VTK_MANGLE_MESA)
    LINK_LIBRARIES( ${MESA_LIBRARY})
    IF ( MESA_OS_LIBRARY )
      LINK_LIBRARIES(${MESA_OS_LIBRARY})
    ENDIF ( MESA_OS_LIBRARY )
  ENDIF (VTK_MANGLE_MESA)

  # add in xwindows stuff
  IF (CMAKE_HAS_X)
    LINK_LIBRARIES(-lXt)
    LINK_LIBRARIES(${CMAKE_X_LIBS})
    ADD_DEFINITIONS(${CMAKE_X_CFLAGS})
  ENDIF (CMAKE_HAS_X)
ENDIF (VTK_USE_RENDERING)

IF (UNIX)
  LINK_LIBRARIES(${THREAD_LIBS} ${DL_LIBS} -lm)
ENDIF (UNIX)
